import * as tsModule from "typescript";
import { Node, SourceFile, TypeChecker, Program } from "typescript";
import { AnalyzerFlavor, ComponentFeatureCollection } from "./chunk-analyzer-flavor-d5336c29";
import { AnalyzerConfig } from "./chunk-analyzer-config-93ab3a41";
import { ComponentDeclaration } from "./chunk-component-declaration-14acf67d";
/**
 * This context is used in the entire analyzer.
 * A new instance of this is created whenever the analyzer runs.
 */
interface AnalyzerVisitContext {
    checker: TypeChecker;
    program: Program;
    ts: typeof tsModule;
    config: AnalyzerConfig;
    flavors: AnalyzerFlavor[];
    emitContinue?(): void;
    cache: {
        featureCollection: WeakMap<Node, ComponentFeatureCollection>;
        componentDeclarationInSourceFile: WeakMap<SourceFile, WeakMap<Node, ComponentDeclaration>>;
        general: Map<unknown, unknown>;
    };
}
export { AnalyzerVisitContext };
//# sourceMappingURL=chunk-analyzer-visit-context-d5336c29.d.ts.map