import { Node, SourceFile, Symbol } from "typescript";
import { ComponentCssPart } from "./chunk-component-css-part-c0c96ec8";
import { ComponentCssProperty } from "./chunk-component-css-property-bf4b003a";
import { ComponentEvent } from "./chunk-component-event-8314091f";
import { ComponentMember } from "./chunk-component-member-d7983be2";
import { ComponentMethod } from "./chunk-component-method-8314091f";
import { ComponentSlot } from "./chunk-component-slot-b8a04bb4";
import { JsDoc } from "./chunk-js-doc-14acf67d";
interface ComponentFeatures {
    members: ComponentMember[];
    methods: ComponentMethod[];
    events: ComponentEvent[];
    slots: ComponentSlot[];
    cssProperties: ComponentCssProperty[];
    cssParts: ComponentCssPart[];
}
type ComponentHeritageClauseKind = "implements" | "extends" | "mixin";
interface ComponentHeritageClause {
    kind: ComponentHeritageClauseKind;
    identifier: Node;
    declaration: ComponentDeclaration | undefined;
}
type ComponentDeclarationKind = "mixin" | "interface" | "class";
interface ComponentDeclaration extends ComponentFeatures {
    sourceFile: SourceFile;
    node: Node;
    declarationNodes: Set<Node>;
    kind: ComponentDeclarationKind;
    jsDoc?: JsDoc;
    symbol?: Symbol;
    deprecated?: boolean | string;
    heritageClauses: ComponentHeritageClause[];
}
export { ComponentFeatures, ComponentHeritageClauseKind, ComponentHeritageClause, ComponentDeclarationKind, ComponentDeclaration };
//# sourceMappingURL=chunk-component-declaration-14acf67d.d.ts.map