import { ComponentDeclaration, ComponentHeritageClause } from "./chunk-component-declaration-14acf67d";
/**
 * Returns the superclass heritage clause
 * @param declaration
 */
declare function getSuperclassHeritageClause(declaration: ComponentDeclaration): ComponentHeritageClause | undefined;
/**
 * Returns mixin heritage clauses for the declaration
 * @param declaration
 */
declare function getMixinHeritageClauses(declaration: ComponentDeclaration): ComponentHeritageClause[];
/**
 * Returns all extends heritage clauses for the declaration
 * @param declaration
 */
declare function getExtendsHeritageClauses(declaration: ComponentDeclaration): ComponentHeritageClause[];
/**
 * Returns mixin heritage clauses for the declaration and all inherited declarations
 * @param declaration
 */
declare function getMixinHeritageClausesInChain(declaration: ComponentDeclaration): ComponentHeritageClause[];
/**
 * Returns extends heritage clauses for the declaration and all inherited declarations
 * @param declaration
 */
declare function getExtendsHeritageClausesInChain(declaration: ComponentDeclaration): ComponentHeritageClause[];
/**
 * A helper function that makes it possible to visit all heritage clauses in the inheritance chain.
 * @param declaration
 * @param emit
 */
declare function visitAllHeritageClauses(declaration: ComponentDeclaration, emit: (clause: ComponentHeritageClause) => void): void;
export { getSuperclassHeritageClause, getMixinHeritageClauses, getExtendsHeritageClauses, getMixinHeritageClausesInChain, getExtendsHeritageClausesInChain, visitAllHeritageClauses };
//# sourceMappingURL=chunk-component-declaration-util-b7d1b209.d.ts.map