import { SimpleType } from "ts-simple-type";
import * as tsModule from "typescript";
import { Node, Program } from "typescript";
import { JsDoc } from "./chunk-js-doc-14acf67d";
/**
 * Returns jsdoc for a given node.
 * @param node
 * @param ts
 */
declare function getJsDoc(node: Node, ts: typeof tsModule): JsDoc | undefined;
declare function getJsDoc(node: Node, tagNames: string[], ts: typeof tsModule): JsDoc | undefined;
/**
 * Converts a given string to a SimpleType
 * Defaults to ANY
 * See http://usejsdoc.org/tags-type.html
 * @param str
 * @param context
 */
declare function parseSimpleJsDocTypeExpression(str: string, context: {
    program: Program;
    ts: typeof tsModule;
}): SimpleType;
/**
 * Finds a @type jsdoc tag in the jsdoc and returns the corresponding simple type
 * @param jsDoc
 * @param context
 */
declare function getJsDocType(jsDoc: JsDoc, context: {
    program: Program;
    ts: typeof tsModule;
}): SimpleType | undefined;
export { getJsDoc, parseSimpleJsDocTypeExpression, getJsDocType };
//# sourceMappingURL=chunk-js-doc-util-767d52e3.d.ts.map