import { SimpleType } from "ts-simple-type";
import { Node, Type } from "typescript";
import { PriorityKind } from "./chunk-analyzer-flavor-d5336c29";
import { ModifierKind } from "./chunk-modifier-kind-d7983be2";
import { VisibilityKind } from "./chunk-visibility-kind-8314091f";
import { ComponentFeatureBase } from "./chunk-component-feature-b8a04bb4";
import { LitElementPropertyConfig } from "./chunk-lit-element-property-config-a6e5ad36";
type ComponentMemberKind = "property" | "attribute";
type ComponentMemberReflectKind = "to-attribute" | "to-property" | "both";
interface ComponentMemberBase extends ComponentFeatureBase {
    kind: ComponentMemberKind;
    node: Node;
    priority?: PriorityKind;
    typeHint?: string;
    type: undefined | (() => Type | SimpleType);
    meta?: LitElementPropertyConfig;
    visibility?: VisibilityKind;
    reflect?: ComponentMemberReflectKind;
    required?: boolean;
    deprecated?: boolean | string;
    default?: unknown;
    modifiers?: Set<ModifierKind>;
}
interface ComponentMemberProperty extends ComponentMemberBase {
    kind: "property";
    propName: string;
    attrName?: string;
}
interface ComponentMemberAttribute extends ComponentMemberBase {
    kind: "attribute";
    attrName: string;
    propName?: undefined;
    modifiers?: undefined;
}
type ComponentMember = ComponentMemberProperty | ComponentMemberAttribute;
export { ComponentMemberKind, ComponentMemberReflectKind, ComponentMemberBase, ComponentMemberProperty, ComponentMemberAttribute, ComponentMember };
//# sourceMappingURL=chunk-component-member-d7983be2.d.ts.map