import { SimpleType } from "ts-simple-type";
import * as tsModule from "typescript";
import { Program } from "typescript";
/**
 * Relax the type so that for example "string literal" become "string" and "function" become "any"
 * This is used for javascript files to provide type checking with Typescript type inferring
 * @param type
 */
declare function relaxType(type: SimpleType): SimpleType;
/**
 * Return a Typescript library type with a specific name
 * @param name
 * @param ts
 * @param program
 */
declare function getLibTypeWithName(name: string, { ts, program }: {
    program: Program;
    ts: typeof tsModule;
}): SimpleType | undefined;
export { relaxType, getLibTypeWithName };
//# sourceMappingURL=chunk-type-util-96b97858.d.ts.map